VERSION 5.00
Object = "{5E9E78A0-531B-11CF-91F6-C2863C385E30}#1.0#0"; "msflxgrd.ocx"
Begin VB.Form Form1 
   Caption         =   "SQL Server Developer's Guide - ODBCDirect Sample"
   ClientHeight    =   6210
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   8520
   LinkTopic       =   "Form1"
   ScaleHeight     =   6210
   ScaleWidth      =   8520
   StartUpPosition =   2  'CenterScreen
   Begin MSFlexGridLib.MSFlexGrid Grid 
      Height          =   4575
      Left            =   2400
      TabIndex        =   0
      Top             =   1080
      Width           =   6015
      _ExtentX        =   10610
      _ExtentY        =   8070
      _Version        =   393216
      FixedCols       =   0
      AllowUserResizing=   1
   End
   Begin VB.CommandButton Command_Next 
      Caption         =   "Next-->"
      Default         =   -1  'True
      Height          =   375
      Left            =   5160
      TabIndex        =   9
      Top             =   5760
      Width           =   1335
   End
   Begin VB.CommandButton Command_Cancel 
      Caption         =   "Cancel"
      Height          =   375
      Left            =   6840
      TabIndex        =   8
      Top             =   5760
      Width           =   1215
   End
   Begin VB.Frame Frame3 
      Height          =   15
      Left            =   120
      TabIndex        =   7
      Top             =   6120
      Width           =   2065
   End
   Begin VB.Frame Frame2 
      Height          =   15
      Left            =   120
      TabIndex        =   6
      Top             =   1080
      Width           =   2055
   End
   Begin VB.Frame Frame4 
      Height          =   5155
      Left            =   120
      TabIndex        =   5
      Top             =   975
      Width           =   15
   End
   Begin VB.Frame Frame5 
      Caption         =   "Frame4"
      Height          =   5175
      Left            =   2160
      TabIndex        =   4
      Top             =   960
      Width           =   15
   End
   Begin VB.TextBox Text_Top 
      Height          =   285
      Left            =   4080
      TabIndex        =   3
      Top             =   1560
      Width           =   2415
   End
   Begin VB.TextBox Text_Bot 
      Height          =   285
      IMEMode         =   3  'DISABLE
      Left            =   4080
      PasswordChar    =   "*"
      TabIndex        =   2
      Top             =   2760
      Width           =   2415
   End
   Begin VB.TextBox Text_Mid 
      Height          =   285
      Left            =   4080
      TabIndex        =   1
      Top             =   2160
      Width           =   2415
   End
   Begin VB.Image Image1 
      Height          =   975
      Left            =   0
      Picture         =   "FormDirect.frx":0000
      Stretch         =   -1  'True
      Top             =   0
      Width           =   8535
   End
   Begin VB.Label Label_Top 
      Caption         =   "Server"
      Height          =   255
      Left            =   4080
      TabIndex        =   14
      Top             =   1320
      Width           =   2415
   End
   Begin VB.Label Label_Bot 
      Caption         =   "Password"
      Height          =   255
      Left            =   4080
      TabIndex        =   13
      Top             =   2520
      Width           =   2415
   End
   Begin VB.Label Label_Mid 
      Caption         =   "Login ID"
      Height          =   255
      Left            =   4080
      TabIndex        =   12
      Top             =   1920
      Width           =   2415
   End
   Begin VB.Label Label1 
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1935
      Left            =   2760
      TabIndex        =   11
      Top             =   1200
      Width           =   5055
   End
   Begin VB.Label Label2 
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   2655
      Left            =   2760
      TabIndex        =   10
      Top             =   3240
      Width           =   5415
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim ws As Workspace
Dim cn As Connection
Dim db As Database
Dim rs As Recordset

Dim sServer As String
Dim sLoginID As String
Dim sPassword As String

Dim nState, iLabel As Integer
Dim lbl_Functions(1 To 23) As VB.Label
Dim intTop As Integer

' Displayed by Form_load
Const sCase0_UpperText = "Welcome." & vbCr & vbCr & "This sample program illustrates how to use ODBCDirect to build SQL Server database applications."
Const sCase0_LowerText = "Press Next to enter your SQL Server connection information."

Const sCase1_LowerText = vbCr & "Enter the name of your SQL Server system and a valid Login ID and Password." & vbCr & vbCr & _
                        "To successfully perfom all of the tasks in this program this ID must have create table authority to the pubs database." & vbCr & vbCr & _
                        "Press next to create an ODBCDirect Workspace using the CreateWorkspace method."

Const sCase2_UpperText = "Congratulations." & vbCr & vbCr & "You have successfully created an ODBCDirect Workspace object."
Const sCase2_LowerText = "Press Next to create an ODBCDirect Workspace object using the default workspace."

Const sCase3_UpperText = "Congratulations." & vbCr & vbCr & "You have successfully created an ODBCDirect Workspace object using the default properties from the DBEngine object."
Const sCase3_LowerText = "Press Next to connect to SQL Server using the OpenDatabase method.  You will be prompted to select an existing DSN to make the connection."

Const sCase4_UpperText = "Congratulations." & vbCr & vbCr & "You have successfully connected to SQL Server using the OpenDatabase method and selecting a DSN"
Const sCase4_LowerText = "Press Next to connect to SQL Server using the OpenConnection method. Once again, you will be prompted to select an existing DSN to make the connection."

Const sCase5_UpperText = "Congratulations." & vbCr & vbCr & "You have successfully connected to SQL Server using the OpenConnection method."
Const sCase5_LowerText = "Press Next to connect to SQL Server using a DSN-less connection with the OpenConnection method."

Const sCase6_UpperText = "Congratulations." & vbCr & vbCr & "You have successfully connected to SQL Server using the DSN-less OpenConnection method."
Const sCase6_LowerText = "Press Next to run a simple query on the authors table using a Dynaset type of recordset object that's derived from the Database object."

Const sCase7_UpperText = "Congratulations." & vbCr & vbCr & "You have successfully used the OpenRecordset method to create a Recordset object that's derived from the Database object."
Const sCase7_LowerText = "Press Next to create a Recordset object that's based on the Connection object."

Const sCase8_UpperText = "Congratulations." & vbCr & vbCr & "You have successfully used the OpenRecordset method to create a Recordset object that's derived from the Conneciton object."
Const sCase8_LowerText = "Press Next to create a prepared SQL statement using a QueryDef object."

Const sCase9_UpperText = "Congratulations." & vbCr & vbCr & "You have successfully executed a prepared SQL using a QueryDef object."
Const sCase9_LowerText = "Press Next to create the department table using dynamic SQL."

Const sCase10_UpperText = "Congratulations." & vbCr & vbCr & "You have successfully created the department table in the pubs database."
Const sCase10_LowerText = "Press Next to add 50 rows to the department table using prepared SQL and a QueryDef object."

Const sCase11_UpperText = "Congratulations." & vbCr & vbCr & "You have successfully added 50 rows to the new department table in the pubs database."
Const sCase11_LowerText = "Press Next to update 50 rows contained in the department table using a Dynaset type of recordset."

Const sCase12_UpperText = "Congratulations." & vbCr & vbCr & "You have successfully updated 50 rows in the department table of the pubs database."
Const sCase12_LowerText = "Press Next to delete 50 rows contained in the department table using a Dynaset type of recordset."

Const sCase13_UpperText = "Congratulations." & vbCr & vbCr & "You have successfully deleted 50 rows from the department table of the pubs database."
Const sCase13_LowerText = "Press Next to create the CountStateRows stored procedure in the pubs database."

Const sCase14_UpperText = "Congratulations." & vbCr & vbCr & "You have successfully created the CountStateRows stored procedure in the pubs database." & vbCr & vbCr & _
                        "This stored procedure counts all of the rows in the authors table where the state is equal to the value supplied in the first parameter."
Const sCase14_LowerText = "It outputs a integer value containing the number of instance that the state value was found in the authors table." & vbCr & vbCr & _
                        "Press Next call the CountStateRows stored procedure using a QueryDef object. This call will use the value of UT for the input parameter."

Const sCase15_UpperText = "Congratulations." & vbCr & vbCr & "You have successfully executed the CountStateRows stored procedure."
Const sCase15_LowerText = "Press Next to demonostrate ODBCDirect error handling.  A runtime error will be generated and displayed in message box."

Const sCase16_UpperText = "Congratulations." & vbCr & vbCr & "You have succesfully generated an ODBCDirect runtime error."
Const sCase16_LowerText = "Press Next to run a multiple result set query."

Const sCase17_UpperText = "Congratulations." & vbCr & vbCr & "You have successfully run a multiple result set query and displayed all of the result sets in the Grid."
Const sCase17_LowerText = "Press Next to run an asynchronous query."

Const sCase18_UpperText = "Congratulations." & vbCr & vbCr & "You have successfully executed an asynchronous query."
Const sCase18_LowerText = "Press Next to display the query results in the grid."

Const sCase19_UpperText = "Congratulations." & vbCr & vbCr & "You have successfully displayed the results of an asynchrouns query."
Const sCase19_LowerText = "Press Next to begin a transaction, add 50 rows to the department table and then commit the transation."

Const sCase20_UpperText = "Congratulations." & vbCr & vbCr & "You have successfully executed a transaction that added 50 rows to the department table."
Const sCase20_LowerText = "Press Next to begin a transaction that updates all 50 rows in the department table but then rolls back the transaction so no update occurs."

Const sCase21_UpperText = "Congratulations." & vbCr & vbCr & "You have successfully rolled back a transaction that updated 50 rows in the department table."
Const sCase21_LowerText = "Press Next to finish the ODBCDirect sample program."

Const sCase22_UpperText = "Congratulations." & vbCr & vbCr & "You have successfully completed the ODBCDirect sample program."
Const sCase22_LowerText = "Press Next to reset the program or Cancel to end this program."

Private Sub CreateODBCDirectWS()

    MousePointer = vbHourglass
    
    'The type parameter sets the workspace to ODBCDirect
    Set ws = DBEngine.CreateWorkspace("NewODBCDirectWS", sLoginID, _
                sPassword, dbUseODBC)
    ws.Close
    
    MousePointer = vbDefault
    
End Sub

Private Sub CreateDefaultODBCDirectWS()

    MousePointer = vbHourglass
    
    'Set the default Workspace type to ODBCDirect
    DBEngine.DefaultType = dbUseODBC

    'Create the default Workspace as ODBCDirect
    Set ws = DBEngine.Workspaces(0)
    ws.DefaultCursorDriver = dbUseODBCCursor
    
    ws.Close
    
    MousePointer = vbDefault

End Sub

Private Sub ConnectOpenDatabase()
    Dim ws As Workspace
    Dim db As Database
    Dim sConnect As String
    
    MousePointer = vbHourglass
    
    'Set the default Workspace type to ODBCDirect
    DBEngine.DefaultType = dbUseODBC

    'Create the default Workspace as ODBCDirect
    Set ws = DBEngine.Workspaces(0)
    ws.DefaultCursorDriver = dbUseODBCCursor
    
    'Setup the Connection String
    sConnect = "ODBC;DSN=;UID=" & sLoginID & _
        ";PWD=" & sPassword & _
        ";Server=" & sServer & _
        ";Database=pubs"
    
    'Create a new Database object
    Set db = OpenDatabase("", dbDriverComplete, False, sConnect)
    db.Close
    ws.Close
    
    MousePointer = vbDefault
    
End Sub

Private Sub ConnectOpenConnection()

    Dim sConnect As String
    Dim cn As Connection

    MousePointer = vbHourglass
    
    sConnect = "ODBC;DSN=;UID=" & sLoginID & _
        ";PWD=" & sPassword & _
        ";Server=" & sServer & _
        ";Database=pubs"
        
    Set cn = OpenConnection("", dbDriverComplete, False, sConnect)
    cn.Close
        
    MousePointer = vbDefault
    
End Sub

Private Sub DSNlessConnectOpenConnection()
    
    Dim sConnect As String
    Dim cn As Connection
    
    MousePointer = vbHourglass
    
    sConnect = "ODBC;Driver=SQL Server;UID=" & sLoginID & _
        ";PWD=" & sPassword & _
        ";Server=" & sServer & _
        ";Database=pubs"
        
    Set cn = OpenConnection("", dbDriverComplete, False, sConnect)
    
    MousePointer = vbDefault
    
End Sub

Private Sub DatabaseQuery()
    
    Dim rs As Recordset
    Dim fld As Field
    Dim sConnect As String
    
    MousePointer = vbHourglass
    
    'Setup the Connection String
    sConnect = "ODBC;Driver=SQL Server;UID=" & sLoginID & _
        ";PWD=" & sPassword & _
        ";Server=" & sServer & _
        ";Database=pubs"
    
    'Create a new Database object
    Set db = OpenDatabase("", dbDriverComplete, False, sConnect)
    
    'Create a Recordset
    Set rs = db.OpenRecordset("Select * From authors", dbOpenDynaset)
    
    DisplayDynasetGrid rs, Grid, 1
    
    rs.Close
    db.Close
                    
    MousePointer = vbDefault

End Sub

Private Sub ConnectionQuery()
    
    Dim rs As Recordset
    Dim fld As Field
    Dim nRow As Integer
    Dim sConnect As String
    
    MousePointer = vbHourglass
    
    sConnect = "ODBC;Driver=SQL Server;UID=" & sLoginID & _
        ";PWD=" & sPassword & _
        ";Server=" & sServer & _
        ";Database=pubs"
        
    Set cn = OpenConnection("", dbDriverComplete, False, sConnect)
    
    Set rs = cn.OpenRecordset("Select * From employee", dbOpenDynaset)
    
    DisplayDynasetGrid rs, Grid, 1
       
    rs.Close
        
    MousePointer = vbDefault

End Sub

 Private Sub QueryDefPS(cn As Connection)
    
    Dim qd As QueryDef
    Dim rs As Recordset
    Dim fld As Field
    Dim nRow As Integer
    Dim sSQL As String
    
    MousePointer = vbHourglass
    
    'Setup the SQL statement
    sSQL = "Select * From authors Where au_id = ?"
    
    'Create the QueryDef object
    ' use a global connection object
    Set qd = cn.CreateQueryDef
    
    ' Prepare the statement
     With qd
        .SQL = sSQL
        .Parameters(0).Direction = dbParamInput
        .Prepare = dbQPrepare
        .Parameters(0).Value = "712-45-1867"
     End With
     
    Set rs = qd.OpenRecordset(dbOpenForwardOnly, False)
    
    ' Setup the grid
    Grid.Cols = rs.Fields.Count
    Grid.Rows = 1
    Grid.Row = 0
    
    'Setup the Grid headings
     For Each fld In rs.Fields
         Grid.Col = fld.OrdinalPosition
         Grid.Text = fld.Name
    Next fld
    
    Grid.Rows = Grid.Rows + 1
    
    'Loop through all fields
    For Each fld In rs.Fields
        Grid.Col = fld.OrdinalPosition
        Grid.Text = fld.Value
    Next fld
    
    qd.Parameters(0).Value = "238-95-7766"
    rs.Requery
    
    Grid.Rows = Grid.Rows + 1
    Grid.Row = Grid.Row + 1
    
    'Loop through all fields
    For Each fld In rs.Fields
        Grid.Col = fld.OrdinalPosition
        Grid.Text = fld.Value
    Next fld
    
    rs.Close
        
    qd.Close
    
    MousePointer = vbDefault

End Sub

Private Sub CreateTable(cn As Connection)

    Dim sSQL As String
    On Error Resume Next
    
    MousePointer = vbHourglass
    
    sSQL = "Drop Table department"
    cn.Execute sSQL
       
    On Error GoTo Errorhandler
    sSQL = "Create Table department (Dep_ID Int Not Null, " _
     & "Dep_Name Char(25), Primary Key(Dep_ID))"
    cn.Execute sSQL
    MousePointer = vbDefault
    Exit Sub
    
Errorhandler:
    DisplayDAOError
    MousePointer = vbDefault
     
End Sub

Private Sub AddUsingQD(cn As Connection)
    
    Dim qd As QueryDef
    Dim i As Integer
    Dim sSQL As String
    Dim rs As Recordset
    
    MousePointer = vbHourglass
    
    sSQL = "Insert Into department Values(?,?)"
    
    Set qd = cn.CreateQueryDef("", sSQL)
    qd.Prepare = dbQPrepare
    
    If qd.Updatable = False Then
        MsgBox "This QueryDef is not updateable", vbOKOnly, App.Title
        Exit Sub
    End If

    For i = 1 To 50
        qd.Parameters(0).Value = CStr(i)
        qd.Parameters(1).Value = "Department " & CStr(i)
        qd.Execute
    Next
   
    qd.Close
    
    Set rs = cn.OpenRecordset("Select * From department", dbOpenDynaset)
    DisplayDynasetGrid rs, Grid, 1
    rs.Close
    
    MousePointer = vbDefault
    
End Sub

Private Sub UpdateUsingQD(cn As Connection)
    Dim qd As QueryDef
    Dim i As Integer
    Dim sSQL As String
    Dim rs As Recordset
    
    MousePointer = vbHourglass
        
    sSQL = "Update department Set Dep_Name = ? Where Dep_ID = ?"
    
    Set qd = cn.CreateQueryDef("", sSQL)
    qd.Prepare = dbQPrepare
    
    For i = 1 To 50
        qd.Parameters(0).Value = "Updated Department " & CStr(i)
        qd.Parameters(1).Value = CStr(i)
        qd.Execute
    Next
   
    qd.Close
    
    Set rs = cn.OpenRecordset("Select * From department", dbOpenDynaset)
    DisplayDynasetGrid rs, Grid, 1
    rs.Close
    
    MousePointer = vbDefault
    
End Sub

Private Sub DeleteUsingQD(cn As Connection)
    Dim qd As QueryDef
    Dim i As Integer
    Dim sSQL As String
    Dim rs As Recordset
    
    MousePointer = vbHourglass
        
    sSQL = "Delete department Where Dep_ID = ?"
    
    Set qd = cn.CreateQueryDef("", sSQL)
    qd.Prepare = dbQPrepare
    
    For i = 1 To 50
        qd.Parameters(0).Value = CStr(i)
        qd.Execute
    Next
   
    qd.Close
        
    Set rs = cn.OpenRecordset("Select * From department", dbOpenDynaset)
    DisplayDynasetGrid rs, Grid, 1
    rs.Close

    MousePointer = vbDefault
End Sub

Private Sub CreateSP(cn As Connection)
    
    Dim sSQL As String
    On Error Resume Next
    
    MousePointer = vbHourglass
    
    sSQL = "Drop Proc CountStateRows"
    cn.Execute sSQL
    
    
    On Error GoTo Errorhandler
    
    sSQL = "Create Proc CountStateRows " _
        & "(@state char(2), @rows Int Output) As " _
        & "Select @rows = Count(*) From authors Where state = @state"
    
    cn.Execute sSQL
    
    MousePointer = vbDefault
    Exit Sub
   
Errorhandler:
    DisplayDAOError
    MousePointer = vbDefault

End Sub

Private Sub CallQDsp(cn As Connection)
    
    Dim qd As QueryDef
    
    Dim sSQL As String
    On Error GoTo Errorhandler
                   
    MousePointer = vbHourglass
    
    sSQL = "{ Call CountStateRows (? ,?) }"
    
    Set qd = cn.CreateQueryDef("", sSQL)
        
    qd.Parameters(0).Value = "UT"
    qd.Parameters(1).Direction = dbParamOutput
    
    qd.Execute
    
    Label_Mid.Caption = "Number of rows:"
    Text_Mid.Text = qd.Parameters(1).Value

    MousePointer = vbDefault
    Exit Sub
   
Errorhandler:
    DisplayDAOError

    MousePointer = vbDefault

End Sub

Private Sub ShowError()
    
    Dim rs As Recordset
    Dim sSQL As String
    On Error GoTo Errorhandler
    
    sSQL = "Select * From no_such_table"
    Set rs = cn.OpenRecordset(sSQL, dbOpenDynaset)
    rs.Close
    
    Exit Sub
    
Errorhandler:
    DisplayDAOError

End Sub

Private Sub MultipleRS(cn As DAO.Connection)

    Dim rs As Recordset
    Dim fld As Field
    Dim sSQL As String
    Dim i As Integer
    
    MousePointer = vbHourglass
    
    'Setup the two SELECT statements
    sSQL = "Select stor_name, city From stores; "
    sSQL = sSQL & "Select title, type From titles; "
    sSQL = sSQL & "Select au_lname, au_fname From authors; "
                    
    Set rs = cn.OpenRecordset(sSQL)
    
    ' Setup the grid
    Grid.FixedRows = 0
    Grid.Cols = 2
    Grid.Rows = 1
    Grid.Row = 0
    i = 1

    Do
        Grid.Col = 0
        Grid.CellBackColor = &HC0C0C0
        Grid.Text = "Recordset"
        Grid.Col = 1
        Grid.CellBackColor = &HC0C0C0
        Grid.Text = "Number: " & i
        
        While rs.EOF = False
            Grid.Rows = Grid.Rows + 1
            Grid.Row = Grid.Row + 1
            'Loop through all fields
            For Each fld In rs.Fields
                Grid.Col = fld.OrdinalPosition
                Grid.Text = fld.Value
                If Grid.ColWidth(Grid.Col) < Me.TextWidth(fld.Value & "AA") Then
                    Grid.ColWidth(Grid.Col) = Me.TextWidth(fld.Value & "AA")
                End If
            Next fld
            rs.MoveNext
        Wend
        
        i = i + 1
    
    Loop Until rs.NextRecordset = False
    
    rs.Close
        
    MousePointer = vbDefault

End Sub

Private Sub AsyncStart(cn As Connection)
    
    Dim sSQL As String
    
    MousePointer = vbHourglass
    
    sSQL = "Select * From employee "
          
    ' Use a global rs to allow access in the AsyncFinish subroutine
    'Start the Async query and move on
    Set rs = cn.OpenRecordset(sSQL, dbOpenDynaset, dbRunAsync)
        
    MousePointer = vbDefault

End Sub

Private Sub AsyncFinish(rs As Recordset)
    
    Dim fld As Field

    MousePointer = vbHourglass

    If rs.StillExecuting = False Then
        DisplayDynasetGrid rs, Grid, 1
        rs.Close
    End If
    
    MousePointer = vbDefault

End Sub

Private Sub TransCommit(ws As Workspace, cn As Connection)

    Dim qd As QueryDef
    Dim rs As Recordset
    Dim fld As Field
    Dim sSQL As String
    Dim i As Integer
        
    MousePointer = vbHourglass
    
    'Check to be sure the data source supports transactions
    If cn.Transactions = True Then
    
        sSQL = "Insert Into department Values(?,?)"
    
        Set qd = cn.CreateQueryDef("", sSQL)
        qd.Prepare = dbQPrepare
        
        'Start a transaction and execute the SQL
        ws.BeginTrans
 
        For i = 0 To 50
            qd.Parameters(0).Value = CStr(i)
            qd.Parameters(1).Value = " Trans Department " & CStr(i)
            qd.Execute
        Next
   
        'Commit the transaction and update the table
        ws.CommitTrans
        
        qd.Close
        
    End If
    
    MousePointer = vbDefault

End Sub
    
Private Sub TransRollBack(ws As Workspace, cn As Connection)

    Dim rs As Recordset
    Dim fld As Field
    Dim sSQL As String

    MousePointer = vbHourglass
    
    'Check to be sure the data source supports transactions
    If cn.Transactions = True Then
        
        'Setup the SQL
        sSQL = "Update department Set Dep_Name = 'NO UPDATE'"
        
        'Start a transaction and execute the SQL
        ws.BeginTrans
        cn.Execute sSQL
        
        'Now Rollback the transaction - the table is unchanged
        ws.Rollback
                
    End If
    
    MousePointer = vbDefault

End Sub

Private Sub DisplayDynasetGrid(rs As Recordset, Grid As MSFlexGrid, nDirection As Integer)
    
    Dim fld As Field
    Dim nForward As Integer
    Dim nReverse As Integer
    On Error Resume Next
    
    nForward = 1
    nReverse = 2
    
    ' Setup the grid
    Grid.Redraw = False
    Grid.Cols = rs.Fields.Count
    rs.MoveLast
    Grid.Rows = rs.RecordCount + 1
    Grid.Row = 0
    Grid.Col = 0
    Grid.FixedRows = 1
    Grid.Clear
            
    'Setup the Grid headings
     For Each fld In rs.Fields
        Grid.Row = 0
         Grid.Col = fld.OrdinalPosition
         Grid.Text = fld.Name
         Grid.ColAlignment(Grid.Col) = 1
         Grid.ColWidth(Grid.Col) = Me.TextWidth(fld.Value & "AA")
    Next fld
    
    If nDirection = nForward Then
    
        rs.MoveFirst
    
        ' Move through each row in the record set
        Do Until rs.EOF
        
            ' Set the position in the grid
            Grid.Row = Grid.Row + 1
            Grid.Col = 0
        
            'Loop through all fields
            For Each fld In rs.Fields
                Grid.Col = fld.OrdinalPosition
                Grid.Text = fld.Value
                If Grid.ColWidth(Grid.Col) < Me.TextWidth(fld.Value & "AA") Then
                    Grid.ColWidth(Grid.Col) = Me.TextWidth(fld.Value & "AA")
                End If
            Next fld
    
            rs.MoveNext
        Loop

    Else

        rs.MoveLast
        
        ' Move through each row in the record set
        Do Until rs.BOF
        
            ' Set the position in the grid
            Grid.Row = Grid.Row + 1
            Grid.Col = 0
        
            'Loop through all fields
            For Each fld In rs.Fields
                Grid.Col = fld.OrdinalPosition
                Grid.Text = fld.Value
                If Grid.ColWidth(Grid.Col) < Me.TextWidth(fld.Value & "AA") Then
                    Grid.ColWidth(Grid.Col) = Me.TextWidth(fld.Value & "AA")
                End If
            Next fld
    
            rs.MovePrevious
            
        Loop

    End If
    
    Grid.Redraw = True
    
End Sub

Private Sub Finish()
End Sub

Private Sub Reset()
    
    'Close any open connections
    cn.Close

    'Initialize the program control values
    Label1.Visible = True
    Label2.Visible = True
    Grid.Visible = False
    Label_Top.Visible = False
    Text_Top.Visible = False
    Label_Mid.Caption = "User ID"
    Label_Mid.Visible = False
    Text_Mid.Visible = False
    Text_Mid.Enabled = True
    Label_Bot.Caption = "Password"
    Label_Bot.Visible = False
    Text_Bot.Visible = False
    Text_Bot.PasswordChar = "*"

    Text_Top.Text = sServer
    Text_Mid.Text = sLoginID
    Text_Bot.Text = sPassword
    
    Label1.Caption = sCase0_UpperText
    Label2.Caption = sCase0_LowerText

End Sub

Private Sub Command_Next_Click()
    If iLabel < 23 Then
        lbl_Functions(iLabel + 1).Enabled = True
        lbl_Functions(iLabel).Enabled = False
    End If
    
    Select Case nState
        Case 1
            'Get the Server, Login and Password that are required to connect
            nState = nState + 1
            iLabel = iLabel + 1
            Label1.Visible = False
            Label_Top.Visible = True
            Label_Mid.Visible = True
            Label_Bot.Visible = True
            Text_Top.Visible = True
            Text_Mid.Visible = True
            Text_Bot.Visible = True
            Text_Top.SetFocus
            Label2.Caption = sCase1_LowerText
        Case 2
            sServer = Text_Top.Text
            sLoginID = Text_Mid.Text
            sPassword = Text_Bot.Text
            CreateODBCDirectWS
            nState = nState + 1
            iLabel = iLabel + 1
            Label1.Visible = True
            Label_Top.Visible = False
            Label_Mid.Visible = False
            Label_Bot.Visible = False
            Text_Top.Visible = False
            Text_Mid.Visible = False
            Text_Bot.Visible = False
            Label1.Caption = sCase2_UpperText
            Label2.Caption = sCase2_LowerText
        Case 3
            CreateDefaultODBCDirectWS
            nState = nState + 1
            iLabel = iLabel + 1
            Label1.Caption = sCase3_UpperText
            Label2.Caption = sCase3_LowerText
        Case 4
            ConnectOpenDatabase
            nState = nState + 1
            iLabel = iLabel + 1
            Label1.Caption = sCase4_UpperText
            Label2.Caption = sCase4_LowerText
        Case 5
            ConnectOpenConnection
            nState = nState + 1
            iLabel = iLabel + 1
            Label1.Caption = sCase5_UpperText
            Label2.Caption = sCase5_LowerText
        Case 6
            DSNlessConnectOpenConnection
            nState = nState + 1
            Label1.Caption = sCase6_UpperText
            Label2.Caption = sCase6_LowerText
        Case 7
            DatabaseQuery
            nState = nState + 1
            iLabel = iLabel + 1
            Grid.Visible = True
        Case 8
            nState = nState + 1
            Grid.Visible = False
            Label1.Caption = sCase7_UpperText
            Label2.Caption = sCase7_LowerText
        Case 9
            ConnectionQuery
            nState = nState + 1
            iLabel = iLabel + 1
            Grid.Visible = True
        Case 10
            nState = nState + 1
            Grid.Visible = False
            Label1.Caption = sCase8_UpperText
            Label2.Caption = sCase8_LowerText
        Case 11
            QueryDefPS cn
            nState = nState + 1
            iLabel = iLabel + 1
            Grid.Visible = True
        Case 12
            nState = nState + 1
            iLabel = iLabel + 1
            Grid.Visible = False
            Label1.Caption = sCase9_UpperText
            Label2.Caption = sCase9_LowerText
        Case 13
            CreateTable cn
            nState = nState + 1
            Label1.Caption = sCase10_UpperText
            Label2.Caption = sCase10_LowerText
        Case 14
            AddUsingQD cn
            nState = nState + 1
            iLabel = iLabel + 1
            Grid.Visible = True
        Case 15
            nState = nState + 1
            Grid.Visible = False
            Label1.Caption = sCase11_UpperText
            Label2.Caption = sCase11_LowerText
        Case 16
            UpdateUsingQD cn
            nState = nState + 1
            iLabel = iLabel + 1
            Grid.Visible = True
        Case 17
            nState = nState + 1
            Grid.Visible = False
            Label1.Caption = sCase12_UpperText
            Label2.Caption = sCase12_LowerText
        Case 18
            DeleteUsingQD cn
            nState = nState + 1
            iLabel = iLabel + 1
            Grid.Visible = True
        Case 19
            nState = nState + 1
            iLabel = iLabel + 1
            Grid.Visible = False
            Label1.Caption = sCase13_UpperText
            Label2.Caption = sCase13_LowerText
        Case 20
            ShiftLabels iLabel - 13
            CreateSP cn
            nState = nState + 1
            Label1.Caption = sCase14_UpperText
            Label2.Caption = sCase14_LowerText
        Case 21
            CallQDsp cn
            nState = nState + 1
            iLabel = iLabel + 1
            Grid.Visible = False
            Label_Mid.Visible = True
            Label_Mid.Caption = "Number of State Rows:"
            Text_Mid.Visible = True
            Label1.Visible = False
            Label2.Visible = False
        Case 22
            ShiftLabels iLabel - 13
            nState = nState + 1
            iLabel = iLabel + 1
            Label_Mid.Visible = False
            Text_Mid.Visible = False
            Grid.Visible = False
            Label1.Visible = True
            Label2.Visible = True
            Label1.Caption = sCase15_UpperText
            Label2.Caption = sCase15_LowerText
        Case 23
            ShiftLabels iLabel - 13
            ShowError
            nState = nState + 1
            Label1.Caption = sCase16_UpperText
            Label2.Caption = sCase16_LowerText
        Case 24
            MultipleRS cn
            nState = nState + 1
            iLabel = iLabel + 1
            Grid.Visible = True
        Case 25
            ShiftLabels iLabel - 13
            nState = nState + 1
            iLabel = iLabel + 1
            Grid.Visible = False
            Label1.Caption = sCase17_UpperText
            Label2.Caption = sCase17_LowerText
        Case 26
            ShiftLabels iLabel - 13
            AsyncStart cn
            nState = nState + 1
            Grid.Visible = False
            Label1.Caption = sCase18_UpperText
            Label2.Caption = sCase18_LowerText
        Case 27
            AsyncFinish rs
            nState = nState + 1
            iLabel = iLabel + 1
            Grid.Visible = True
        Case 28
            ShiftLabels iLabel - 13
            nState = nState + 1
            Grid.Visible = False
            Label1.Caption = sCase19_UpperText
            Label2.Caption = sCase19_LowerText
        Case 29
            TransCommit ws, cn
            nState = nState + 1
            iLabel = iLabel + 1
            Grid.Visible = False
        Case 30
            ShiftLabels iLabel - 13
            nState = nState + 1
            Grid.Visible = False
            Label1.Caption = sCase20_UpperText
            Label2.Caption = sCase20_LowerText
        Case 31
            TransRollBack ws, cn
            nState = nState + 1
            iLabel = iLabel + 1
            Grid.Visible = False
        Case 32
            ShiftLabels iLabel - 13
            nState = nState + 1
            iLabel = iLabel + 1
            Grid.Visible = False
            Label1.Caption = sCase21_UpperText
            Label2.Caption = sCase21_LowerText
        Case 33
            ShiftLabels iLabel - 13
            Finish
            nState = nState + 1
            iLabel = iLabel + 1
            Grid.Visible = False
            Label1.Caption = sCase22_UpperText
            Label2.Caption = sCase22_LowerText
        Case 34
            lbl_Functions(iLabel - 13).Visible = False
            Reset
            nState = 1
            iLabel = 1
            ResetLabels
            lbl_Functions(1).Enabled = True
        End Select

End Sub

Private Sub Form_Activate()
    ' reposition the last labels
    PositionLabels
End Sub

Private Sub Form_Load()
    ' build labels
    BuildLabels
    
    ' set up object if to resize
    InitObjectsToResize Me
    
    'Initial the program control values
    nState = 1
    iLabel = 1
    'List1.Visible = False
    Label_Top.Visible = False
    Text_Top.Visible = False
    Label_Mid.Visible = False
    Text_Mid.Visible = False
    Label_Bot.Visible = False
    Text_Bot.Visible = False
    Grid.Visible = False
    
    Grid.Rows = 1
    Grid.Cols = 2
    Grid.Row = 0

    Label1.Caption = sCase0_UpperText
    Label2.Caption = sCase0_LowerText
    
End Sub

Private Sub Form_Resize()
    ' resize the forms objects
    ResizeObjects Me
End Sub

Private Sub DisplayDAOError()
        
    Dim er As Error
    
    For Each er In Errors
        MsgBox "Number: " & er.Number & vbCrLf & _
        "Source: " & er.Source & vbCrLf & _
        "Text: " & er.Description
    Next
        
End Sub

Private Sub Form_Unload(Cancel As Integer)
    
    On Error Resume Next
    
    Set DBEngine = Nothing
    
End Sub

Private Sub Command_Cancel_Click()
    End
End Sub

Public Sub InitObjectsToResize(frm As Form)
    Dim obj As Object
    On Error Resume Next
    For Each obj In frm.Controls
        If obj.Left < 0 Then obj.Left = 0
        If obj.Top < 0 Then obj.Top = 0
        If obj.Top > frm.ScaleHeight Then obj.Top = frm.ScaleHeight - 360
        If obj.Width > frm.ScaleWidth Then obj.Width = frm.ScaleWidth
        If obj.Height > frm.ScaleHeight Then obj.Height = frm.ScaleHeight
        obj.Tag = Format$(obj.Left / frm.ScaleWidth, ".0000") _
                & Format$(obj.Top / frm.ScaleHeight, ".0000") _
                & Format$(obj.Width / frm.ScaleWidth, ".0000") _
                & Format$(obj.Height / frm.ScaleHeight, ".0000")
    Next obj
End Sub

Public Sub ResizeObjects(frm As Form)
    Dim obj As Object
    On Error Resume Next
    For Each obj In frm.Controls
        obj.Move Val(Mid$(obj.Tag, 1, 5)) * frm.ScaleWidth, _
                Val(Mid$(obj.Tag, 6, 5)) * frm.ScaleHeight, _
                Val(Mid$(obj.Tag, 11, 5)) * frm.ScaleWidth, _
                Val(Mid$(obj.Tag, 16, 5)) * frm.ScaleHeight
    Next obj
    
    intTop = lbl_Functions(2).Top - lbl_Functions(1).Top
    PositionLabels
End Sub

Public Sub BuildLabels()
    Dim iCount, iTop As Integer
    
    iTop = 1200
    For iCount = 1 To 23
        Set lbl_Functions(iCount) = Form1.Controls.Add("VB.Label", "lbl_Functions" & iCount, Me)
        lbl_Functions(iCount).AutoSize = True
        lbl_Functions(iCount).Enabled = False
        lbl_Functions(iCount).Height = 195
        lbl_Functions(iCount).Left = 230
        lbl_Functions(iCount).Top = iTop
        lbl_Functions(iCount).Visible = True
        Select Case iCount
            Case 1
                lbl_Functions(iCount).Caption = "Connection Information"
                lbl_Functions(iCount).Enabled = True
            Case 2
                lbl_Functions(iCount).Caption = "Create Workspace"
            Case 3
                lbl_Functions(iCount).Caption = "Create Default Workpace"
            Case 4
                lbl_Functions(iCount).Caption = "DSN OpenDatabase"
            Case 5
                lbl_Functions(iCount).Caption = "DSN OpenConnection"
            Case 6
                lbl_Functions(iCount).Caption = "DSN-less OpenConnection"
            Case 7
                lbl_Functions(iCount).Caption = "Database Query"
            Case 8
                lbl_Functions(iCount).Caption = "Connection Query"
            Case 9
                lbl_Functions(iCount).Caption = "Prepared QueryDef"
            Case 10
                lbl_Functions(iCount).Caption = "Create Table"
            Case 11
                lbl_Functions(iCount).Caption = "Add w/QueryDef"
            Case 12
                lbl_Functions(iCount).Caption = "Update w/QueryDef"
            Case 13
                lbl_Functions(iCount).Caption = "Delete w/QueryDef"
            Case 14
                lbl_Functions(iCount).Caption = "Create Stored Procedure"
            ' build controls on page to allow resizing. will position them later
            Case 15
                lbl_Functions(iCount).Top = iTop - 360
                lbl_Functions(iCount).Caption = "Call Stored Procedure"
            Case 16
                lbl_Functions(iCount).Top = iTop - 360
                lbl_Functions(iCount).Caption = "Show Error"
            Case 17
                lbl_Functions(iCount).Top = iTop - 360 * 2
                lbl_Functions(iCount).Caption = "Multiple Result Sets"
            Case 18
                lbl_Functions(iCount).Top = iTop - 360 * 3
                lbl_Functions(iCount).Caption = "Async Query"
            Case 19
                lbl_Functions(iCount).Top = iTop - 360 * 4
                lbl_Functions(iCount).Caption = "Async Query Results"
            Case 20
                lbl_Functions(iCount).Top = iTop - 360 * 5
                lbl_Functions(iCount).Caption = "Trans Commit"
            Case 21
                lbl_Functions(iCount).Top = iTop - 360 * 6
                lbl_Functions(iCount).Caption = "Trans Roll Back"
            Case 22
                lbl_Functions(iCount).Top = iTop - 360 * 7
                lbl_Functions(iCount).Caption = "Finish"
            Case 23
                lbl_Functions(iCount).Top = iTop - 360 * 8
                lbl_Functions(iCount).Caption = "Reset"
        End Select
        iTop = iTop + 360
    Next iCount
    intTop = 360
End Sub

Public Sub PositionLabels()
    Dim iScrollMove, iTop As Integer
    iTop = (intTop * 14) + lbl_Functions(1).Top
    For iScrollMove = 1 To 9
        lbl_Functions(iScrollMove + 14).Top = iTop
        iTop = iTop + intTop
    Next iScrollMove
End Sub

Public Sub ResetLabels()
    Dim iScrollMove, iTop As Integer
    iTop = (intTop * 9) + lbl_Functions(1).Top
    For iScrollMove = 1 To 23
        lbl_Functions(iScrollMove).Visible = True
        lbl_Functions(iScrollMove).Top = iTop
        iTop = iTop + intTop
    Next iScrollMove
End Sub

Public Sub ShiftLabels(iShift As Integer)
    Dim iMove As Integer
    lbl_Functions(iShift).Visible = False
    For iMove = 1 To 14
        lbl_Functions(iMove).Top = (Val(Mid$(lbl_Functions(iMove).Tag, 6, 5)) * Me.ScaleHeight) - (intTop * iShift)
    Next iMove
    For iMove = 15 To 23
        lbl_Functions(iMove).Top = lbl_Functions(iMove).Top - intTop
    Next iMove
End Sub

