DECLARE @idoc int
DECLARE @doc varchar(1000) 
SET @doc = ' 
<ROOT> 
  <authors authorID="1111" 
        fname="Michael"
        lname="Otey"
	address="123 E. Street"
	city="Portland"
	mailcode="97236"
	phone="503-555-1212"
	ssn="111-11-1111" />
  <authors authorID="2222" 
        fname="Paul"
        lname="Conte"
	address="123 E. Street"
	city="Eugene"
	mailcode="97236"
	phone="503-555-1212"
	ssn="222-22-2222" />
</ROOT>'

--Create an internal representation of the XML document. 
EXEC sp_xml_preparedocument @idoc OUTPUT, @doc
-- Execute a SELECT statement that uses the OPENXML rowset provider. 
SELECT * FROM OPENXML (@idoc, '/ROOT/authors',1) 
  WITH (fname  varchar(20),
 	lname  varchar(20),
	address  varchar(20),
       	city  varchar(20))
EXEC sp_xml_removedocument @idoc


