VERSION 5.00
Object = "{0ECD9B60-23AA-11D0-B351-00A0C9055D8E}#6.0#0"; "mshflxgd.ocx"
Begin VB.Form frmQuery 
   Caption         =   "SQL Server Developer's Guide EQ Sample"
   ClientHeight    =   6885
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   8535
   LinkTopic       =   "Form1"
   ScaleHeight     =   6885
   ScaleWidth      =   8535
   StartUpPosition =   2  'CenterScreen
   Begin MSHierarchicalFlexGridLib.MSHFlexGrid hflxResults 
      Height          =   2655
      Left            =   120
      TabIndex        =   6
      Top             =   4080
      Width           =   8295
      _ExtentX        =   14631
      _ExtentY        =   4683
      _Version        =   393216
      FixedCols       =   0
      AllowUserResizing=   1
      _NumberOfBands  =   1
      _Band(0).Cols   =   2
   End
   Begin VB.Frame Frame2 
      Caption         =   "Generated SQL"
      Height          =   1335
      Left            =   120
      TabIndex        =   4
      Top             =   2640
      Width           =   8295
      Begin VB.Label lblSQL 
         BorderStyle     =   1  'Fixed Single
         Height          =   975
         Left            =   120
         TabIndex        =   5
         Top             =   240
         Width           =   7935
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   "Enter your English Query"
      Height          =   1455
      Left            =   120
      TabIndex        =   0
      Top             =   1080
      Width           =   8295
      Begin VB.CommandButton cmdRunEQ 
         Caption         =   "Submit Query"
         Height          =   495
         Left            =   6720
         TabIndex        =   3
         Top             =   720
         Width           =   1335
      End
      Begin VB.TextBox txtEnglish 
         Height          =   855
         Left            =   120
         MultiLine       =   -1  'True
         TabIndex        =   2
         Text            =   "frmQuery.frx":0000
         Top             =   360
         Width           =   6375
      End
   End
   Begin VB.Image Image1 
      Height          =   975
      Left            =   0
      Picture         =   "frmQuery.frx":0028
      Stretch         =   -1  'True
      Top             =   0
      Width           =   8535
   End
   Begin VB.Label Label1 
      Caption         =   "Label1"
      Height          =   15
      Left            =   3000
      TabIndex        =   1
      Top             =   600
      Width           =   135
   End
End
Attribute VB_Name = "frmQuery"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub cmdRunEQ_Click()
    Dim oEQSession As New Mseq.Session
    Dim oEQResponse As Mseq.Response
    
    Dim oEQCommandResponse As Mseq.CommandResponse
    Dim oEQClarify As Mseq.UserClarifyResponse
    Dim oEQError As Mseq.ErrorResponse
    
    Dim sSQL As String
    Dim cn As New ADODB.Connection
    Dim rs As New ADODB.Recordset
    Dim i As Integer
    
    ' Initialize the Sesison with the compiled model
    oEQSession.InitDomain (App.Path & "\EQSample.eqd")
    
    ' Parse the English query request
    Set oEQResponse = oEQSession.ParseRequest(txtEnglish.Text)
        
    ' Clear the Grid display
    hflxResults.Clear
    hflxResults.Rows = 2
    hflxResults.Cols = 2
        
    ' Evaluate the results of the parser
    Select Case oEQResponse.Type
      Case nlResponseCommand
        'Success - run the query
        Set oEQCommandResponse = oEQResponse
        
        Select Case oEQCommandResponse.Commands(0).CmdID
        
            Case nlCmdQuery
                sSQL = oEQCommandResponse.Commands(0).SQL
                lblSQL.Caption = sSQL
                
                If sServer = vbNullString Then
                    frmLogin.Show vbModal
                End If
                
                'Open a connect to SQL Server using ADO
                cn.Open ("DRIVER=SQL Server" & _
                    ";SERVER=" & sServer & _
                    ";UID=" & sLoginID & _
                    ";PWD=" & sPassword & _
                    ";DATABASE=Northwind")
                ' Open a recordset using the SQL returned by EQ
                rs.Open sSQL, cn
                ' Display the recordset in a grid
                Set hflxResults.DataSource = rs
                ' Close the ADO recordset and connection objects
                rs.Close
                cn.Close
               
            Case nlCmdAnswer
                lblSQL.Caption = oEQCommandResponse.Commands(0).Answer
            End Select
            
            Set oEQCommandResponse = Nothing
    
      Case nlResponseCmdclarify, nlResponseUserclarify
        ' Query heeds to be clarified
        Set oEQClarify = oEQResponse
        lblSQL.Caption = oEQClarify.UserInputs(0).Caption
        Set oEQClarify = Nothing
    
      Case nlResponseError
        ' Parsing endied in error
        Set oEQError = oEQResponse
        lblSQL.Caption = "Error: " & oEQError.Description
        Set oEQError = Nothing
                
      End Select
      
      'Release the EQ objects
      Set oEQResponse = Nothing
      Set oEQSession = Nothing
      
  
End Sub
